#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/mman.h>
#include <sys/resource.h>

#include <linux/i2c.h>
#include <linux/i2c-dev.h>

#include "gpio.h"

static int zone = 1;

int verbose;

static int
get_status ()
{
  char msgbuf[1];
  i2c(zone, 2, 0, msgbuf, 1);
  return msgbuf[0];
}

int
main(int argc, char **argv)
{
  int s, os = -1;
  int i, ts, te;

  setbuf(stdout, 0);
  i2c_open ();

  zone = 5;

  for (i=1; i<argc; i++)
    {
      if (strcmp (argv[i], "-z") == 0)
	{
	  zone = atoi(argv[i+1]);
	  i ++;
	}
    }

  for (i=1; i<argc; i++)
    {
      if (strcmp (argv[i], "-z") == 0)
	{
	  zone = atoi(argv[i+1]);
	  i ++;
	}
    }

  i = 0;
  while (1)
    {
      s = get_status ();
      if (s != i)
	{
	  printf("%10d %x\n", msclock(), s);
	  i = s;
	}
    }

  i2c_close ();
  return 0;
}
