.include "r8c-ports.S"

;;; We use Timer X.  We want a 1msec interrupt, or a divide-by-20000.
;;; So, we use f1, prescale by 200, and count by 100.  This gives us a
;;; millisecond counter that wraps at ~65 seconds

	.data

	.global	_msec
_msec:	.short	0

	.global	_msec_timeout
_msec_timeout:	.short	0

	.text

	.global	_msec_init
_msec_init:
	mov.b	#0x00,txmr
	mov.b	#200,prex
	mov.b	#100,tx
	mov.b	#0x00,tcss	; X f1, Z f1
	mov.w	#irq_msec,ivect_timera ; also timer X
	mov.b	#5,txic
	bset	_txs,txmr
	rts

irq_msec:
	add.w	#1,_msec
	cmp.w	#0,_msec_timeout
	jeq	1f
	add.w	#-1,_msec_timeout
1:	
	reit
